-- In this new version I want to have a table of rules that gets checked in order, and the first rule that matches generates the hail
condhail.rules = {}

-- Each rule should have a name, hail message, and a table of criteria, which are compared AND-wise in order to successfully match a hail rule.
--condhail.rules[1] = {"Sedina B-8", "Put on your red shoes and dance the blues...", {{"sector", 4978}}}
--condhail.rules[2] = {"Guild [ITAN]", "May the peace of Eo be with you, Comrade.", {{"guild", "Itan"}}}
--condhail.rules[3] = {"CtC Xith Serco", "Hail, pilot! The Purified Xithricite you are carrying is property of the Itani Defense Force. Drop the cargo, or be destroyed!", {{"faction", "2"},{"cargo", "Purified Xithricite Ore"}}}
--condhail.rules[4] = {"CtC Xith", "Hail, pilot! The Purified Xithricite you are carrying is property of the Itani Defense Force. Proceed directly to Divinia M-14 under my escort, drop the cargo, or be destroyed!", {{"cargo", "Purified Xithricite Ore"}}}
--condhail.rules[5] = {"NPC wtf", "wtf", {{"npc", ""}}}
--condhail.rules[6] = {"Die Serco!", "Prepare to die, Serco scum!", {{"faction", 2},{"standing", {1, 13108, "<"}},{"standing", {"sector", 32768, "<"}}}}
--condhail.rules[7] = {"default", "Hail, from the Coalition of Itan!", {{"dummy", ""}}}

condhail.defaultrules = {}
condhail.defaultrules[1] = {"default", "Hail, %target%. ", {{"dummy", ""}}}
--TODO: add more examples to give people an idea how to use this.

function condhail:addrule(name, message)
    local rule = {name, message, {}}
    self:dprint(self.rules)
    table.insert(self.rules, rule)
end

function condhail:moverule(from, to)
    from = tonumber(from)
    to = tonumber(to)
    if self.rules[from] and self.rules[to] then
        table.insert(self.rules, to, table.remove(self.rules,from))
    end
end

function condhail:delrule(id)
    id = tonumber(id)
    if self.rules[id] then
        table.remove(self.rules, id)
    end
end


function condhail:saverules()
    local saveme = {}
    saveme.version = condhail.version
    saveme.rules = condhail.rules
    SaveSystemNotes(spickle(saveme), condhail.systemnotes)
end

function condhail:loadrules()
    local loadme = {}
    loadme = unspickle(LoadSystemNotes(condhail.systemnotes))
    if loadme and type(loadme) == "table" then
        if loadme.rules and loadme.version then
            -- TODO:Validate rules first
            condhail.rules = loadme.rules 
        else
            condhail.rules = condhail.defaultrules
        end
        --TODO:Migrate rules from older versions 
    end
end

function condhail:validrule(rule)
    -- Check rule for bullshit and return true if none is found
    -- I have no idea if this will actually work.
    if not rule then return false 
    elseif type(rule) ~= "table" then return false 
    elseif #rule ~= 3 then return false
    elseif (not rule[1]) or (type(rule[1]) ~= "string") then return false
    elseif (not rule[2]) or (type(rule[2]) ~= "string") then return false
    elseif (not rule[3]) or (type(rule[3]) ~= "table") then return false
    else return true
    end -- not done yet
    -- TODO: finish this.
end

